package blusunrize.immersiveengineering.client.render;

import blusunrize.immersiveengineering.api.tool.BelljarHandler.IPlantHandler;
import blusunrize.immersiveengineering.client.ClientUtils;
import blusunrize.immersiveengineering.common.IEContent;
import blusunrize.immersiveengineering.common.blocks.metal.TileEntityBelljar;
import net.minecraft.block.state.IBlockState;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.*;
import net.minecraft.client.renderer.block.model.IBakedModel;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.client.renderer.vertex.DefaultVertexFormats;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.client.model.obj.OBJModel.OBJState;
import net.minecraftforge.common.property.IExtendedBlockState;
import net.minecraftforge.common.property.Properties;
import org.lwjgl.opengl.GL11;

import java.util.Arrays;

public class TileRenderBelljar extends TileEntitySpecialRenderer<TileEntityBelljar>
{
	@Override
	public void func_180535_a(TileEntityBelljar tile, double x, double y, double z, float partialTicks, int destroyStage)
	{
		if(tile.dummy!=0 || !tile.func_145831_w().func_175668_a(tile.func_174877_v(), false))
			return;

		final BlockRendererDispatcher blockRenderer = Minecraft.func_71410_x().func_175602_ab();
		BlockPos blockPos = tile.func_174877_v();
		IBlockState state = func_178459_a().func_180495_p(blockPos);
		if(state.func_177230_c() != IEContent.blockMetalDevice1)
			return;
		state = state.func_177230_c().func_176221_a(state, func_178459_a(), blockPos);
		IBakedModel model = blockRenderer.func_175023_a().func_178125_b(state);
		if(state instanceof IExtendedBlockState)
			state = ((IExtendedBlockState)state).withProperty(Properties.AnimationProperty, new OBJState(Arrays.asList("glass"), true));

		ClientUtils.bindAtlas();
		GlStateManager.func_179094_E();
		GlStateManager.func_179137_b(x, y, z);

		VertexBuffer worldRenderer = Tessellator.func_178181_a().func_178180_c();
		RenderHelper.func_74518_a();
		GlStateManager.func_179112_b(770, 771);
		GlStateManager.func_179147_l();
		GlStateManager.func_179129_p();
		if(Minecraft.func_71379_u())
			GlStateManager.func_179103_j(7425);
		else
			GlStateManager.func_179103_j(7424);
		worldRenderer.func_181668_a(GL11.GL_QUADS, DefaultVertexFormats.field_176600_a);
		worldRenderer.func_178969_c(-blockPos.func_177958_n(), -blockPos.func_177956_o(), -blockPos.func_177952_p());
		worldRenderer.func_181669_b(255, 255, 255, 255);
		blockRenderer.func_175019_b().func_178267_a(tile.func_145831_w(), model, state, blockPos, worldRenderer, true);
		worldRenderer.func_178969_c(0.0D, 0.0D, 0.0D);
		Tessellator.func_178181_a().func_78381_a();

		IPlantHandler plantHandler = tile.getCurrentPlantHandler();
		if(plantHandler==null)
		{
			GlStateManager.func_179121_F();
			RenderHelper.func_74519_b();
			return;
		}

		GlStateManager.func_179089_o();
		GlStateManager.func_179137_b(0, 1.0625, 0);
		GlStateManager.func_179114_b(-90,0,1,0);
		GlStateManager.func_179131_c(1,1,1,1);
		float scale = plantHandler.getRenderSize(tile.getInventory()[1], tile.getInventory()[0], tile.renderGrowth, tile);
		GlStateManager.func_179109_b((1-scale)/2, 0, -(1-scale)/2);
		GlStateManager.func_179152_a(scale,scale,scale);
		if(!plantHandler.overrideRender(tile.getInventory()[1], tile.getInventory()[0], tile.renderGrowth, tile, blockRenderer))
		{
			IBlockState[] states = plantHandler.getRenderedPlant(tile.getInventory()[1], tile.getInventory()[0], tile.renderGrowth, tile);
			if(states==null || states.length<1)
				return;
			for(IBlockState s : states)
			{
				model = blockRenderer.func_184389_a(s);
				GlStateManager.func_179094_E();
				blockRenderer.func_175019_b().func_178266_a(model, s, 1, true);
				GlStateManager.func_179121_F();
				GlStateManager.func_179109_b(0, 1, 0);
			}
		}
		GlStateManager.func_179121_F();
		RenderHelper.func_74519_b();
	}
}
